#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "stm8s.h"
#include "usrlib-lcd.h"

void LCD_Init(void)
{
	volatile int i;
	GPIO_Init(GPIOG, GPIO_PIN_0, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD DB0
	GPIO_Init(GPIOG, GPIO_PIN_1, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD DB1
	GPIO_Init(GPIOE, GPIO_PIN_5, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD E
	GPIO_Init(GPIOC, GPIO_PIN_5, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD RS
	GPIO_Init(GPIOC, GPIO_PIN_6, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD DB2
	GPIO_Init(GPIOC, GPIO_PIN_7, GPIO_MODE_OUT_PP_HIGH_FAST); // LCD DB3
	GPIO_Init(GPIOD, GPIO_PIN_0, GPIO_MODE_OUT_PP_HIGH_FAST); // LED

  // LCD contrast PWD (TIM3_CH1 [43pin])
	TIM3_DeInit();
	TIM3_TimeBaseInit( TIM3_PRESCALER_1, 159 ); // 16MHz/1/160=100kHz
  TIM3_OC1Init( TIM3_OCMODE_PWM1, TIM3_OUTPUTSTATE_ENABLE, 20, TIM3_OCPOLARITY_HIGH );
	TIM3_Cmd(ENABLE);

	for(i=0;i<=20000;i++){;} // wait 20mS
	LCD_Write_Nibble(LCD_REG_FUNC,0b0011);
	for(i=0;i<=5000;i++){;} // wait 5mS
	LCD_Write_Nibble(LCD_REG_FUNC,0b0011);
	for(i=0;i<=20;i++){;} // wait 100uS
	LCD_Write_Nibble(LCD_REG_FUNC,0b0011);
	LCD_Write_Nibble(LCD_REG_FUNC,0b0010); // 4bit
	LCD_Write_Nibble(LCD_REG_FUNC,0b0010); // 4bit
	LCD_Write_Nibble(LCD_REG_FUNC,0b1000); // 2lines 5x7dots
	LCD_Write_Nibble(LCD_REG_FUNC,0b0000);
	LCD_Write_Nibble(LCD_REG_FUNC,0b1000); // display off
	LCD_Write_Nibble(LCD_REG_FUNC,0b0000);
	LCD_Write_Nibble(LCD_REG_FUNC,0b0001); // clear display
	for(i=0;i<=2000;i++){;} // 2mS wait
	LCD_Write_Nibble(LCD_REG_FUNC,0b0000);
	LCD_Write_Nibble(LCD_REG_FUNC,0b1100); // increment not-shift
}

// LCD 4bit transfer routine (50uSec wait)
void LCD_Write_Nibble(u8 RS,char C)
{
	volatile int i;
	if(RS==0)	      GPIO_WriteLow ( GPIOC, GPIO_PIN_5 ); // RS
	if(RS==1)	      GPIO_WriteHigh( GPIOC, GPIO_PIN_5 );
	if((C&1)==0)    GPIO_WriteLow ( GPIOG, GPIO_PIN_0 ); // DB0=data[0]
	if((C&1)==1)    GPIO_WriteHigh( GPIOG, GPIO_PIN_0 );
	if((C&2)==0)    GPIO_WriteLow ( GPIOG, GPIO_PIN_1 ); // DB1=data[1]
	if((C&2)==2)    GPIO_WriteHigh( GPIOG, GPIO_PIN_1 );
	if((C&4)==0)    GPIO_WriteLow ( GPIOC, GPIO_PIN_6 ); // DB2=data[2]
	if((C&4)==4)    GPIO_WriteHigh( GPIOC, GPIO_PIN_6 );
	if((C&8)==0)    GPIO_WriteLow ( GPIOC, GPIO_PIN_7 ); // DB3=data[3]
	if((C&8)==8)    GPIO_WriteHigh( GPIOC, GPIO_PIN_7 );
	GPIO_WriteHigh( GPIOE, GPIO_PIN_5 ); // E
	GPIO_WriteLow ( GPIOE, GPIO_PIN_5 );
	for(i=0;i<=20;i++){;} // wait 50uS
}

void LCD_Write_Char(u8 RS,char C)
{
	LCD_Write_Nibble(RS,C>>4);
	LCD_Write_Nibble(RS,C);
}

void LCD_Disp_Str(char *str, u8 line)
{
	int i;
	for(i=0;i<=strlen(str)-1;i++)
	{
		if(i==0)
		{
			if(line==LCD_DISP_UPPERLINE) LCD_Write_Char(LCD_REG_FUNC,0b10000000); // DDRAM-adrs=0
			if(line==LCD_DISP_LOWERLINE) LCD_Write_Char(LCD_REG_FUNC,0b11000000); // DDRAM-adrs=40H
		}
		LCD_Write_Char(LCD_REG_CHAR,str[i]);
	}
}
