// LCD routines
//
// LCD routines are designed for SC1062 TYPE LCD module.
// LCD routines are designed to use 16MHz fCPU.
// LCD routines use TIM3 timer and its interrupt.
// 
// External pin definitions:
//   PC7 DB7 14 13 DB6 PC6
//   PG1 DB5 12 11 DB4 PG0
//   --- DB3 10  9 DB2 ---
//   --- DB1  8  7 DB0 ---
//   PE5   E  6  5 RW  GND
//   PC5  RS  4  3 Vo  PD2(TIM3_CH1)
//   GND GND  2  1 Vcc 5V
//-----------------------------------------------

// LCD initialization routine
void LCD_Init(void);

// LCD write rourtine
// parameter:
//  RS: register select
//     LCD_REG_FUNC: function register is written
//     LCD_REG_CHAR: character register is written
//  C: a character or 8bit data
#define LCD_REG_FUNC  0
#define LCD_REG_CHAR  1
void LCD_Write_Nibble(u8 RS, char C); // 4bit write
void LCD_Write_Char(u8 RS, char C); // 1bit write

// LCD string write routine
//
// LCD has upper and lower lines.
#define LCD_DISP_UPPERLINE 0
#define LCD_DISP_LOWERLINE 1
void LCD_Disp_Str(char *str, u8 line);
